/*
Szerencsés szám
*/

#include <fstream>
#include <iostream>
//#include <ctime>

using namespace std;

ofstream fout("A_5.out");

void szerencsesSzam_a(int x, int & start, bool & szerencses){

  	int xNegyzet = x * x;
  	szerencses = false;
  	start = -1;
  	int k = 1;
  	int s = 0;
  	while ((k <= xNegyzet - x) and !szerencses){
    	for(int i = k; i <= k + x - 1; i++)
      		s = s + i;
    	if(s == xNegyzet){
      		szerencses = true;
      		start = k;    
    	}
    	k++;
  	}
}

void szerencsesSzam_b(int x, int & start, bool & szerencses){

    int xNegyzet = x * x;
    szerencses = false;
    start = -1;
    int k = 1;
    while((k <= xNegyzet - x) and !szerencses){
      	int s = 0;
      	for(int i = k; i <= k + x - 1; i++)
        	s = s + i;
      	if(s == xNegyzet){
        	szerencses = true;
        	start = k;
      	}  
      	k++;
    }
}

void szerencsesSzam_c(int x, int & start, bool & szerencses){
  	
  	if(x % 2 == 0){
    	szerencses = false;
    	start = -1;
  	}
  	else{
    	szerencses = true;
    	start = (x + 1) / 2;
  	}
}

void szerencsesSzam_d(int x, int & start, bool & szerencses){

  	if(x % 2 == 0) {
    	szerencses = false;
    	start = -1;
  	}
  	else{
    	szerencses = true;
    	start = x / 2;
  	} 
}

void szerencsesSzam_e(int x, int & start, bool & szerencses){
  	if(x % 2 != 0) {
    	szerencses = true;
    	start = x / 2 - 1;
  	}
  	else{
    	szerencses = false;
    	start = -1;
  	}
}

int main(){

int start;
bool szerencses;
  	for(int x = 2; x <= 20; x++){
    	szerencsesSzam_a(x, start, szerencses);
    	if(szerencses)
      		fout << "A: x = " << x << " szerencses szam es start = " << start << endl;
    	
    	szerencsesSzam_b(x, start, szerencses);
    	if(szerencses)
      		fout << "B: x = " << x << " szerencses szam es start = " << start << endl;
    	
    	szerencsesSzam_c(x, start, szerencses);
    	if(szerencses)
      		fout << "C: x = " << x << " szerencses szam es start = " << start << endl;

    	szerencsesSzam_d(x, start, szerencses);
    	if(szerencses)
      		fout << "D: x = " << x << " szerencses szam es start = " << start << endl;

    	szerencsesSzam_e(x, start, szerencses);
    	if(szerencses)
      		fout << "E: x = " << x << " szerencses szam es start = " << start << endl;
    	fout << endl;
  	}
}
