/*
Számolás karakterekkel
*/

#include <iostream>
#include <fstream>
#include <string.h>
#include <string>

using namespace std;

ifstream fin("B_1.in");

void beOlvas(string & s, int & hossz){
// beolvasás és átalakítás úgy, hogy a tulajdobképpeni karakterlánc az 1 indexűvel kezdődjön 

    fin >> s;
    hossz = 0;
    while(s[hossz]){
        hossz++;
    }
	string ss = "0";    
    for(int i = 0; i < hossz; i++)
        ss = ss + s[i];    
    s = ss;
}

void kiIr(string s, int hossz){
// az 1 indexű helyen kezdődő karakterlánc kiírása

    cout << "A karakterlanc: ";
    for(int i = 1; i <= hossz; i++){
        cout << s[i];
    }
    cout << " , amelynek hossza = " << hossz << endl;
}

int szamolasKarakterekkelIterativ(string s, int n, int p, int q, int szam){
// meghatarozza és téríti a karakterláncban található számok összegét  

	int eredmeny = 0;
    int i = p;
	while(i <= q){
		while(i <= q and s[i] >= '0' and s[i] <= '9') {
			szam = szam * 10 + s[i] - '0';	// egy szám
			i++;
		}
		eredmeny = eredmeny + szam;			// hozzáadjuk a szám értékét s-hez
		szam = 0;							// lehet, lesz még szám
		i++;								// haladunk a karakterláncban
	} 
	return eredmeny;
}

int szamolasKarakterekkelRek(string s, int n, int p, int q, int szam){
// meghatarozza és téríti a karakterláncban található számok összegét (rekurzívan) 

	if(p > q) 
		return szam;
	else
		if(s[p] < '0' or s[p] > '9')  
			return szam + szamolasKarakterekkelRek(s, n, p + 1, q, 0);
		else
			return szamolasKarakterekkelRek(s, n, p + 1, q, 10 * szam + s[p] - '0');
}

int main(){
    string s;
	int hossz;    

	int p = 1;
	cout << "p = 1 es q = a karakterlanc hossza (ellenorzes celjabol)" << endl;
    for(int i = 1; i <= 6; i++){
        beOlvas(s, hossz);
        kiIr(s, hossz);
        int q = hossz;
        cout << "A szamok osszege (iterativ) = " << szamolasKarakterekkelIterativ(s, hossz, p, q, 0) << endl;
        cout << "A szamok osszege (rekurziv) = " << szamolasKarakterekkelRek(s, hossz, p, q, 0) << endl << endl;
    }
}
