/*
Periódus
*/

#include<iostream>
#include<fstream>
#include<string.h>

using namespace std;

ifstream fin("B_2.in");

void beOlvas(int & n, char x[]){
// beolvasás és átalakítás ahhoz, hogy az 1 indexű helyen kezdődjön

  	fin >> n;
  	fin >> x;
  	//cout << "x, ahogy beolvastuk = " << x << endl;
  	int hossz = 0;
    while(x[hossz]){
        hossz++;
    }

	char ss[200];
	ss[0] = '0';    
    for(int i = 1; i <= hossz; i++){
        ss[i] = x[i - 1];
    }
    hossz++;
    ss[hossz] = '\0';	// stringvége: null karakter

    for(int i = 0; i <= hossz; i++){
    	x[i] = ss[i];
    }
}

void bemenetKiIrasa(int n, char x[]){
  
  	cout << "hossz = " << n << endl;
    for(int i = 1; i <= n; i++)
      cout << x[i];
    cout << endl;
}

bool ellenoriz(int n, char x[], int periodus){
// ellenorzi, hogy "periodus" valúban periódus 

	for(int i = periodus; i < n; ++i) {
    //cout << "Hasonlitjuk az " << i + 1 << " indexu elemet a " << i % periodus + 1 << " indexu elemmel" << endl;
		if(x[i + 1] != x[i % periodus + 1])
			return false;
	}
	return true;
}

int periodusMax(int n, char x[]){
// a leghosszabb periódus meghatározása

	int periodus = -1;
	for(int per = 2; per * per <= n; ++per){  // lehetséges periódus hosszúságok: 2..int(sqrt(n)), 
                                            // de a per <= sqrt(n) helyett per * per <= n
		//cout << "per = " << per << endl;
    if(n % per == 0){                       // ahhoz, hogy "per" periodus legyen, osztania kell n-t
      //cout << "a periodus, amit kiprobalunk = " << n / per << endl;
			if(ellenoriz(n, x, n / per))          // ha n / per valóban periódus
				return n / per;
			if((per * per < n) && ellenoriz(n, x, per)) {// ha n / per nem volt jó, a következő, amit ellenőrzünk per
        //cout << "periodus = " << per << endl;
				periodus = per;                     // ha per megfelelt, ő a periódus
			}                                     // folytatódik a Minden, de van egy „tartalék” periódusunk 
		}
	}
	return periodus;
}

int main() {

int n;
char x[200];

  	for(int i = 1; i <= 8; i++){    
    	beOlvas(n, x);
    	bemenetKiIrasa(n, x);
  		cout << "periodus hossza = " << periodusMax(n, x) << endl << endl;
  	}
}
