/* 
Polinom értéke
*/

#include <iostream>
#include <fstream>

using namespace std;

ifstream f("poli.in");

int const maxDim = 100;

void beOlvas(int & n, float egyh[], float & x){

  f >> n;
  for(int i = 1; i <= n + 1; i++)
    f >> egyh[i];
  f >> x;
}

void kiIrBemenet(int n, float egyh[], float x){

  cout << "n = " << n << endl;
  for(int i = 1; i <= n + 1; i++)
    cout << egyh[i] << " ";
  cout << endl << "x = " << x << endl;
}

float kiertekelesIt(int n, float egyh[], float x){

	float ertek = 0;
	for(int i = 1; i <= n + 1; i++)
		ertek = ertek * x + egyh[i];        // Horner séma
	
	return ertek;
}

float kiertekelesRek(int n, float egyh[], float x){

	if(n == 0)
		return egyh[1];
	else
		return kiertekelesRek(n - 1, egyh, x) * x + egyh[n + 1];
}

int main(){	
	int n;
	float egyh[maxDim];
	float x;
  
  	beOlvas(n, egyh, x);
  	kiIrBemenet(n, egyh, x);

  	cout << "P(" << x << ") = " << kiertekelesIt(n, egyh, x) << endl;
  	cout << "P(" << x << ") = " << kiertekelesRek(n, egyh, x) << endl;
}
