/* 
Tmbszakasz  testvrszmok nlkl
*/

#include <iostream>
#include <fstream>

using namespace std; 

ifstream f("nemTestverek.in");

const int cif = 10;					// szmjegyek statisztikatmjnek hossza
const int maxDim = 10000;

void beOlvas(int & n, int x[]){
// beolvass  

  f >> n;
  for(int i = 1; i <= n; i++)
  	f >> x[i];
}

void kiIrSorozat(int n, int x[]){
// kirs
	
	for(int i = 1; i <= n; i++)
		cout << x[i] << " ";
	cout << endl;
}

bool testverSzamok(int a, int b){
// meghatrozzuk az a szmjegyeinek statisztikavektort  
// majd rendre vizsgljuk, hogy a b szmjegye szerepelt-e a-ban

	bool szamjegyek_A[cif];
	for(int i = 0; i < 10; i++)
		szamjegyek_A[i] = false;
	while(a > 0){
		szamjegyek_A[a % 10] = true;
		a = a / 10;
	}
	int kozosSzj = 0;
	while(b > 0) {
		if(szamjegyek_A[b % 10]){
			kozosSzj++;
			szamjegyek_A[b % 10] = false;// ahhoz, hogy ne szmoljuk meg mg egyszer
		}
		b = b / 10;
	}
	return kozosSzj >= 2;
}

void testverNelkul(int n, int a[], bool testver[]){
// felepitjk a testvr sorozatot, amely azokat az elemeket trolja
// amelyeknek nincs testvrk a-ban

	for(int i = 1; i <= n; i++){
		int j = 1;
		testver[i] = false;
		while(j <= n && !testver[i]){
			if(i != j)
				testver[i] = testverSzamok(a[i], a[j]);
			j++;
		}
	}
}

void leghosszabbTombszakasz(int n, int a[], bool testver[], int & m, int b[], int & startMax){	
// a leghosszabb tmbszakasz, amely nem tartalmaz testvrszmokat

	startMax = 1;
	int vegeMax = 1;
	int startAkt = 1;
	int vegeAkt = 1;
	int i = 1;
	while(i <= n){
		if(!testver[i]){
			startAkt = i;
			while(!testver[i] && (i <= n))
				i++;
			vegeAkt = i - 1;
        	if((vegeMax - startMax) < (vegeAkt - startAkt)){
              	startMax = startAkt;
              	vegeMax = vegeAkt;
        	}
    	}
        i++;
	}
	m = 0;
	for(int i = startMax; i <= vegeMax; i++){
		m++;
		b[m] = a[i];
	}
}

int main(){
int n, k, startMax;
int a[maxDim], b[maxDim]; 
bool testver[maxDim];
	
  	beOlvas(n, a);
  	kiIrSorozat(n, a);
  	
  	testverNelkul(n, a, testver);
	leghosszabbTombszakasz(n, a, testver, k, b, startMax);
	cout << "k = " << k << " a start = " << startMax << " pozicion kezdodik" << endl;
	cout << "Ellenorzes celjabol: " << endl;
	cout << "Leghoszabb testverek nelkuli tombszakasz:" << endl;
	kiIrSorozat(k, b);
}

