/*
Kifejezes
*/

#include <iostream>
//#include <ctime>

using namespace std;

int kifejezes(int n){
	if(n > 0) {
		if(n % 2 == 0) 
			return -n * (n + 1) + kifejezes(n - 1);
		else
			return n * (n + 1) + kifejezes(n - 1);
	}
	else
		return 0;
}

int kifIt_A(int n){
// a.	E(n) = 1* 2 - 2 * 3 + 3 * 4 + ... + (-1)n+1 * n * (n + 1)
	int E = 0;
	for(int i = 1; i <= n; i++)
		if(i % 2 == 0)
			E -= i*(i+1);
		else
			E += i*(i+1);
	return E;
}

int kifIt_B(int n){
// B.	E(n) = 1 * 2 - 2 * 3 + 3 * 4 + ... + (-1)n * n * (n + 1)
	int E = 0;
	for(int i = 1; i < n; i++)
		if(i % 2 == 0)
			E -= i*(i+1);
		else
			E += i*(i+1);
	int r = 1;
	for(int i = 1; i <= n; i++)
		r *= -1;
	E += r * n * (n + 1);
	return E;
}

int kifIt_C(int n){
// c. E(n) = 1* 2 + 2 * 3 + 3 * 4 + ... + (-1)n+1 * n * (n + 1)
	int E = 0;
	for(int i = 1; i <= n; i++)
		if(i % 2 == 0)
			E += i*(i+1);
		else
			E += i*(i+1);
	return E;
}

int kifIt_D(int n){
// d.	E(n) = 1 * 2 + 2 * 3 + 3 * 4 + ... + (-1)n * n * (n + 1)
	int E = 0;
	for(int i = 1; i < n; i++)
		if(i % 2 == 0)
			E = i*(i+1);
		else
			E += i*(i+1);
	int r = 1;
	for(int i = 1; i <= n; i++)
		r *= -1;
	E += r * n * (n + 1);
	return E;
}

int main(){
	for(int n = 2; n <= 4; n++){
		cout << "n = " << n << endl;
		cout << "Rekurziv: " << kifejezes(n) << endl;
		cout << "Iterativ_A: " << kifIt_A(n) << endl;
		cout << "Iterativ_B: " << kifIt_B(n) << endl;
		cout << "Iterativ_C: " << kifIt_C(n) << endl;
		cout << "Iterativ_D: " << kifIt_D(n) << endl;
	}
}
