/*
RobiKert
*/

#include <iostream>
#include <fstream>

using namespace std;

ifstream fin("B_3.in");

int const maxDim = 200000;

void beOlvas(int &n, int d[], int u[], int &t){
	
	fin >> n;
	for(int i = 1; i <= n; i++)
		fin >> d[i];
	for(int i = 1; i <= n; i++)
		fin >> u[i];
	fin >> t;
}

void bemenetKiIrasa(int &n, int d[], int u[], int &t){
	
	cout << "Bemeneti adatok: " << endl;
	cout << "n = " <<  n << endl;
	cout << "d[] : ";
	for(int i = 1; i <= n; i++)
		cout << d[i] << " ";
	cout << endl;
	cout << "u[] : ";
	for(int i = 1; i <= n; i++)
		cout << u[i] << " ";
	cout << endl;
	cout << "t = " <<  t << endl;
}

int robiKert(int n, int d[], int u[], int t){
	int aux[200000]; 						// aux[i]-ban tároljuk az i. pillanatban szükséges vízcsapokat 
	int max = 1;
	for(int i = 1; i <= t; i++)
		aux[i] = 0;
	for(int j = 1; j <= n; j++){
		cout << j << ". robot az uton oda-vissza + ontozes + toltes: ";
		int q = d[j] * 2 + u[j] + 1;		// növeljük a q többszöröseit az aux tömbben
		cout << q << endl;
		for(int i = q; i <= t; i = i + q){
			aux[i]++;
			if(max < aux[i]) 				// meghatározzuk az aux tömb maximumát
				max = aux[i];
		}
	}
	cout << "ahany robot talalkozik a vizcsapnal az 1.." << t << " idopillanatokban:" << endl;
	for(int i = 1; i <= t; i++)
		cout << aux[i] << " ";
	cout << endl;
	return max - 1;
}

int main(){
	int n;
	int d[10], u[10];
	int t;
	for(int i = 1; i <= 2; i++){
		beOlvas(n, d, u, t);
		cout << i << ". teszt: " << endl;
		bemenetKiIrasa(n, d, u, t);
		int vizCs = robiKert(n, d, u, t);
		cout << "Fel kell szerelni meg " << vizCs << " vizcsapot." << endl;	
	}
}
