/*
Egyesítés
*/

#include <iostream>
#include <fstream>

using namespace std;

ifstream fin("egyesites_A.in");// rendre cserélni B, C, D, E-re

int const maxDim = 100;

int hiv1 = 0, hiv2 = 0;

void beOlvas(int &n, int x[]){
	
	fin >> n;
	for(int i = 1; i <= n; i++)
		fin >> x[i];
}

void kiIrSorozat(int n, int x[]){

	cout << "hossz = " << n << endl;
	for(int i = 1; i <= n; i++)
		cout << x[i] << " ";
	cout << endl;
}

bool eleme(int x, int b[], int m){

	int i = 1;
	while(i <= m && x != b[i])
		i++;
	return i <= m;
}

void egyesites(int a[], int n, int b[], int m, int c[], int & p){
	
	hiv2++;
	if(n == 0)  
		for(int i = 1; i <= m; i++){
			p = p + 1;
			c[p] = b[i]; 
		} 
	else{ 
		if(not eleme(a[n], b, m)) { 
			p = p + 1;
			c[p] = a[n]; 
		}
		hiv1++;
		egyesites(a, n - 1, b, m, c, p);
	}
}

void szamol(int a[], int n, int b[], int m, int c[], int & p){

	p = 0;
	egyesites(a, n, b, m, c, p);
	kiIrSorozat(p, c);
}

int main(){

	int n, m, p;
	int x[maxDim], y[maxDim], z[2*maxDim];
	
	beOlvas(n, x);
	beOlvas(m, y);

	cout << "Az x soroxat: " << endl;
	kiIrSorozat(n, x);

	cout << "Az y sorozat: " << endl;
	kiIrSorozat(m, y);

	szamol(x, n, y, m, z, p);
	cout << "A z sorozat: " << endl;
	kiIrSorozat(p, z);	
	
	cout << endl << "hivasok szama a 12. sorban = " << hiv1 << endl;
	cout << endl << "hivasok szama a 2. sorban = " << hiv2 << endl;
}
	
