/*
Beazonosítás
*/

#include <iostream>

using namespace std;

int beazonositas_A(int n){
int a, b, c, d;
	a = 1;
	b = 1; 
	c = 1;
	while(c < n) {
		a = a + 1;
		b = a;
		c = c + 1; 
		d = 2;
		while(c <= n && d <= a / 2) {
			if(a % d == 0) {
				c = c + 1; 
				b = d; 
			}
			d = d + 1;
		}
	}
	return b;
}

int beazonositas_B(int n){
int a, b, c, d;
	a = 1;
	b = 1; 
	c = 1;
	while(c < n) {
		c = c + 1; 
		d = 2;
		while(c <= n && d <= a / 2) {
			if(a % d == 0) {
				c = c + 1; 
				b = d; 
			}
			d = d + 1;
		}
		a = a + 1; 
		b = a;
	}
	return b;
}

int beazonositas_C(int n){
int a, b, c, d;
	a = 1;
	b = 1; 
	c = 1;
	while(c < n) {
		a = a + 1; 
		d = 2;
		while(c < n && d <= a) {
			if(a % d == 0) {
				c = c + 1; 
				b = d; 
			}
			d = d + 1;
		}
	}
	return b;
}

int beazonositas_D(int n){
int a, b, c, d;
	a = 1;
	b = 1; 
	c = 1;
	while(c < n) {
		b = a; 
		a = a + 1; 
		c = c + 1; 
		d = 2;
		while(c <= n && d <= a / 2){ 
			if(a % d == 0){
				c = c + 1; 
				b = d;
			} 
			d = d + 1;
		}
	}
	return b;
}

int beazonositas_E(int n){// OK
int a, b, c, d;
bool f;
	a = 1;
	b = 1; 
	c = 1;
	while(c < n) {
		a = a + 1; 
		b = a;
		c = c + 1; 
		d = 2;
		f = false;
		while(c <= n && d <= a / 2) {
			if(a % d == 0) {
				c = c + 1; 
				b = d; 
				f = true;
			}
			d = d + 1;
		}
		if(f)  
			c = c - 1;
	}
	return b;
}

int ertelmezve_E(int n){// OK
int elem, ujElem, szamlalo, oszto;
bool volt;
	elem = 1;
	ujElem = 1; 
	szamlalo = 1;
	while(szamlalo < n) {
		elem = elem + 1; 
		ujElem = elem;
		szamlalo = szamlalo + 1; 
		oszto = 2;
		volt = false;
		while(szamlalo <= n && oszto <= elem / 2) {
			if(elem % oszto == 0) {
				szamlalo = szamlalo + 1; 
				ujElem = oszto; 
				volt = true;
			}
			oszto = oszto + 1;
		}
		if(volt)  
			szamlalo = szamlalo - 1;
	}
	return ujElem;
}

int main(){

int n = 10;
	cout << "A: " << beazonositas_A(n) << endl;
	cout << "B: " << beazonositas_B(n) << endl;
	cout << "C: " << beazonositas_C(n) << endl;
	cout << "D: " << beazonositas_D(n) << endl;
	cout << "E: " << beazonositas_E(n) << endl;
	cout << "ertelmezve_E: " << ertelmezve_E(n) << endl;	
}   

